/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package org.cocktail.sapics.client.gui;

import java.awt.BorderLayout;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.fwkcktlcompta.client.metier.EOPlanComptableExer;
import org.cocktail.sapics.client.swing.TableSorter;
import org.cocktail.sapics.client.swing.ZEOTable;
import org.cocktail.sapics.client.swing.ZEOTableModel;
import org.cocktail.sapics.client.swing.ZEOTableModelColumn;
import org.cocktail.sapics.client.utilities.CocktailConstantes;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 */
public class PlanComptableSelectView extends javax.swing.JDialog {

    private static final long serialVersionUID = 1L;
    
    private EODisplayGroup eod;
    private ZEOTable myEOTable;
    private ZEOTableModel myTableModel;

    private TableSorter myTableSorter;
    
    /**
     * Creates new form PlanComptableSelectView
     */
    public PlanComptableSelectView(java.awt.Frame parent, boolean modal) {
        this(parent, modal, null);
    }
   
    /**
     * Creates new form PlanComptableSelectView
     */
    public PlanComptableSelectView(java.awt.Frame parent, boolean modal, EODisplayGroup displayGroup) {
        super(parent, modal);
        
        this.eod = displayGroup;
        
        initComponents();
        initGui();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabelCompte = new javax.swing.JLabel();
        jLabelLibelle = new javax.swing.JLabel();
        viewTableListeComptes = new javax.swing.JPanel();
        jTextFieldSrchNumeroCompte = new javax.swing.JTextField();
        jTextFieldSrchLibelleCompte = new javax.swing.JTextField();
        buttonSelectionner = new javax.swing.JButton();
        buttonAnnuler = new javax.swing.JButton();
        buttonFind = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Sélection d'un compte");
        setModal(true);
        setPreferredSize(new java.awt.Dimension(602, 354));

        jLabelCompte.setText("Compte :");

        jLabelLibelle.setText("Libellé :");

        viewTableListeComptes.setLayout(new java.awt.BorderLayout());

        buttonSelectionner.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonSelectionnerActionPerformed(evt);
            }
        });

        buttonAnnuler.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonAnnulerActionPerformed(evt);
            }
        });

        buttonFind.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonFindActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewTableListeComptes, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(0, 0, Short.MAX_VALUE)
                        .add(buttonAnnuler, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 35, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(buttonSelectionner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 35, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(jLabelCompte)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jTextFieldSrchNumeroCompte, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabelLibelle)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jTextFieldSrchLibelleCompte, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 281, Short.MAX_VALUE)
                        .add(18, 18, 18)
                        .add(buttonFind, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 35, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, buttonFind, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(jLabelCompte)
                        .add(jTextFieldSrchNumeroCompte, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(jLabelLibelle)
                        .add(jTextFieldSrchLibelleCompte, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(viewTableListeComptes, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 190, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(buttonSelectionner, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
                    .add(buttonAnnuler, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .add(0, 0, 0))
        );

        setSize(new java.awt.Dimension(610, 312));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void buttonSelectionnerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonSelectionnerActionPerformed
        dispose();
    }//GEN-LAST:event_buttonSelectionnerActionPerformed

    private void buttonAnnulerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonAnnulerActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_buttonAnnulerActionPerformed

    private void buttonFindActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonFindActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_buttonFindActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(PlanComptableSelectView.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(PlanComptableSelectView.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(PlanComptableSelectView.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(PlanComptableSelectView.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                PlanComptableSelectView dialog = new PlanComptableSelectView(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonAnnuler;
    private javax.swing.JButton buttonFind;
    private javax.swing.JButton buttonSelectionner;
    private javax.swing.JLabel jLabelCompte;
    private javax.swing.JLabel jLabelLibelle;
    private javax.swing.JTextField jTextFieldSrchLibelleCompte;
    private javax.swing.JTextField jTextFieldSrchNumeroCompte;
    private javax.swing.JPanel viewTableListeComptes;
    // End of variables declaration//GEN-END:variables
    
    private void initGui() {
        getButtonFind().setIcon(CocktailConstantes.ICON_LOUPE_16);
        getButtonSelectionner().setIcon(CocktailConstantes.ICON_VALID);
        getButtonAnnuler().setIcon(CocktailConstantes.ICON_CANCEL);
        
        List<ZEOTableModelColumn> columnsDefinition = new ArrayList<ZEOTableModelColumn>();

        ZEOTableModelColumn numeroCompteColumn = new ZEOTableModelColumn(eod, EOPlanComptableExer.PCO_NUM_KEY, "Compte", 60);
        numeroCompteColumn.setAlignment(SwingConstants.LEFT);
        
        ZEOTableModelColumn libelleCompteColumn = new ZEOTableModelColumn(eod, EOPlanComptableExer.PCO_LIBELLE_KEY, "Libellé", 160);
        libelleCompteColumn.setAlignment(SwingConstants.LEFT);
        
        columnsDefinition.add(numeroCompteColumn);
        columnsDefinition.add(libelleCompteColumn);

        this.myTableModel = new ZEOTableModel(eod, columnsDefinition);
        this.myTableSorter = new TableSorter(myTableModel);
        this.myEOTable = new ZEOTable(myTableSorter);
        this.myEOTable.setRowSelectionAllowed(true);
        this.myEOTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
        
        this.viewTableListeComptes.removeAll();
        this.viewTableListeComptes.add(new JScrollPane(myEOTable), BorderLayout.CENTER);
    }

    /**
     * @return the buttonAnnuler
     */
    public javax.swing.JButton getButtonAnnuler() {
        return buttonAnnuler;
    }

    /**
     * @return the buttonSelectionner
     */
    public javax.swing.JButton getButtonSelectionner() {
        return buttonSelectionner;
    }
    
    public ZEOTableModel getMyTableModel() {
        return myTableModel;
    }

    public ZEOTable getMyEOTable() {
        return myEOTable;
    }

    /**
     * @return the jTextFieldSrchLibelleCompte
     */
    public javax.swing.JTextField getjTextFieldSrchLibelleCompte() {
        return jTextFieldSrchLibelleCompte;
    }

    /**
     * @return the jTextFieldSrchNumeroCompte
     */
    public javax.swing.JTextField getjTextFieldSrchNumeroCompte() {
        return jTextFieldSrchNumeroCompte;
    }

    /**
     * @return the buttonFind
     */
    public javax.swing.JButton getButtonFind() {
        return buttonFind;
    }
}
